(***********************************************************************)
(*  v      *   The Coq Proof Assistant  /  The Coq Development Team    *)
(* <O___,, *        INRIA-Rocquencourt  &  LRI-CNRS-Orsay              *)
(*   \VV/  *************************************************************)
(*    //   *      This file is distributed under the terms of the      *)
(*         *       GNU Lesser General Public License Version 2.1       *)
(***********************************************************************)

(* $Id: conv_oracle.mli,v 1.3 2002/08/02 17:17:27 coq Exp $ *)

open Names
open Closure

(* Order on section paths for unfolding.
   If [oracle_order kn1 kn2] is true, then unfold kn1 first.
   Note: the oracle does not introduce incompleteness, it only
   tries to postpone unfolding of "opaque" constants. *)
val oracle_order : table_key -> table_key -> bool

(* Changing the oracle *)
val set_opaque_const      : kernel_name -> unit
val set_transparent_const : kernel_name -> unit

val set_opaque_var      : identifier -> unit
val set_transparent_var : identifier -> unit

(*****************************)

(* transparent state summary operations *)
val init     : unit -> unit
val freeze   : unit -> transparent_state
val unfreeze : transparent_state -> unit
